/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package actions;

import java.awt.event.ActionEvent;

import dialogs.PaneTaillePolice;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CListeObjets;

@SuppressWarnings("serial")
public class ActionDiminuerTailles extends MtgAction {
  public ActionDiminuerTailles(MtgFrame frameInit) {
    super(frameInit, null, getString("menuDiminuerTailles"),
    		getString("menuDiminuerTailles"), iconeAssociee(), null, true);
  }
  
  @Override
  public int idMenu() {
    return 33041;
  }
  
  // Une icne pour la version 5.0
  public static String iconeAssociee() {
    return "images/DiminuerTailles";   
  }
  
  @Override
  public void actionPerformed(ActionEvent e) {
  	super.actionPerformed(e);
  	MtgInternalFrame cadre = frame.cadreActif();
  	if (cadre != null) {
  		CListeObjets list = cadre.listePr;
  		boolean done = list.diminueTaillePolices(cadre);
  		if (done) {
	  		cadre.repaintFigureAvecCalcul();
	  		cadre.gestionnaire.enregistreFigureEnCoursPourZoom(getString("chaineOutil164"));
  		}
  		if (frame.pref_IndiceTaillePoliceAffichages > PaneTaillePolice.taillePolicemin) frame.pref_IndiceTaillePoliceAffichages--;
  		if (frame.pref_indiceTaillePoliceNom > PaneTaillePolice.taillePolicemin) frame.pref_indiceTaillePoliceNom--;
  	}
  }

}
