/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;

import objets.CListeObjets;
import types.NatureObjet;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionEditionCopierCodeTikz extends MtgAction {
	public ActionEditionCopierCodeTikz(MtgFrame frameInit) {
		super(frameInit, null, getString("menuEditionCopierCodeTikz"), getString("menuEditionCopierCodeTikz"), null, null, false);
	}
  public int idMenu() {
    return 57636;
  }
	public void actionPerformed(ActionEvent e) {
		MtgInternalFrame cadre = frame.cadreActif();
		CListeObjets liste = cadre.listePr;
		if (cadre != null) {
			// La ligne suivante modifi version 4.9.1
			if (((cadre.document.imageFond != null) || (liste.nombreObjetsParNature(NatureObjet.NImage) != 0)) && cadre.document.path.isEmpty()) {
				frame.dialogueAvertissement(getString("messageFichierNonEnregistre"));
				return;
			}
			cadre .document.exporteImages();
			// On applique le coefficient d'agrandissement-rduction des prfrences
			double coef = Math.sqrt(frame.pref_ClipboardImagesRatio);
			// On copie la figure sans tenir compte de lalongueur unit
			Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(frame.cadreActif().getTikz(coef, false,false)), null);
		}
	}

}
