/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.util.ListIterator;
import java.util.Vector;

import javax.swing.JList;
import javax.swing.ListSelectionModel;

import mathgraph32.MtgFrame;
import objets.CElementBase;
import objets.CFonc;
import objets.CListeObjets;
import objets.CValeurDynamique;
import types.FonteNom;
import types.NatureCalcul;

@SuppressWarnings("serial")
public class ListeFonctionsReellesSansDerivees extends JList<String> {
  private CListeObjets liste; // La liste contenant les valeurs  afficher
  private int indiceMaxi; // l'indice maxi permis pour un objet  insrer dans la liste
  private CFonc fonctionARajouter; // La fonction  rajouter dans la liste (peut tre null)
  public Vector<CValeurDynamique> pointeurs;

  public ListeFonctionsReellesSansDerivees(MtgFrame frame, CListeObjets listeInit, int indiceMaxiInit, CFonc fonctionARajouterInit) {
    super();
		setFont(FonteNom.getFonteEdition(MtgFrame.sizeFontList, FonteNom.Normal,
				(double)frame.pref_addSystemFont/MtgFrame.sizeFontList + MtgFrame.coefMultForSystemFonts));		
    indiceMaxi = indiceMaxiInit;
    fonctionARajouter = fonctionARajouterInit;
    pointeurs = new Vector<CValeurDynamique>();
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    liste = listeInit;
    int i = 0;
    
    Vector<String> values = new Vector<String> ();
    // On ajoute les noms des objets de type valeurs  la liste
    ListIterator<CElementBase> li = liste.listIterator();
    while (i <= indiceMaxi)
    {
      CElementBase elb = li.next();
      if (!elb.estElementIntermediaire() && elb.estDeNatureCalcul(NatureCalcul.NFonctionReelle1Variable)) {
      	CFonc fonc = (CFonc) elb;
      	if (fonc.deriveePossible(0)) {
	      	if (!liste.contientDeriveeDe(fonc) || (fonc == fonctionARajouter)) {
		        values.add(((CValeurDynamique)elb).nom());
		        pointeurs.add((CValeurDynamique) elb);
	      	}
      	}
      }
      i++;
    }
    setListData(values);
    setVisibleRowCount(10);
    setSelectedIndex(0);
  }
  
  public CFonc fonctionSelectionnee() {
  	int ind = getSelectedIndex();
  	if (ind == -1) return null;
  	else return (CFonc) pointeurs.get(ind);
  }
  
  public void setSel(CFonc fonc) {
  	int ind = pointeurs.indexOf(fonc);
  	setSelectedIndex(ind);
  	ensureIndexIsVisible(ind);
  }
}
