/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JToolBar;


@SuppressWarnings("serial")
public class PaneInsertionCaractere extends JPanel {
	public JComponent editeurAssocie; // Pointera sur un JTextField ou un JTextArea
	private int nombreCarParLigne = 8;
	private int nombreCar;
	private JToolBar toolbar;
	
	/** Constructeur */
	public PaneInsertionCaractere(int nombreCarParLigneInit) {
		super();
		nombreCarParLigne = nombreCarParLigneInit;
		nombreCar = -1;
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
	}
	public void associeA(JComponent editeur) {
		editeurAssocie = editeur;
	}
	
	public void ajouteCar(int codecar) {
		MtgCharButton button = new MtgCharButton(codecar, this);
		nombreCar++;
		if ((nombreCar % nombreCarParLigne) == 0) {
			toolbar = new JToolBar(JToolBar.HORIZONTAL);
			toolbar.setBorder(BorderFactory.createEmptyBorder());
			add(toolbar);
		}
		toolbar.add(button);
	}
	
	public void ajouteBouton(MtgCharButtonLatex button) {
		nombreCar++;
		if ((nombreCar % nombreCarParLigne) == 0) {
			toolbar = new JToolBar(JToolBar.HORIZONTAL);
			toolbar.setBorder(BorderFactory.createEmptyBorder());
			add(toolbar);
		}
		toolbar.add(button);		
	}
}
