/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.FlowLayout;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import mathgraph32.MtgFrame;
import types.FonteNom;

@SuppressWarnings("serial")
public class PanePreferencePoliceSysteme extends PaneOptionsPreferences {
	public JList<String> listeDecalages;

	public PanePreferencePoliceSysteme(MtgFrame frameInit) {
		super(frameInit);
		initComponents();
	}
	
	private void initComponents() {
		MtgLabel label1 = new MtgLabel(frame, MtgFrame.getString("paneListeDecalages1"));
		listeDecalages= new JList<String>();
		listeDecalages.setFont(FonteNom.getFonteEdition(MtgFrame.sizeFontList, FonteNom.Normal,
				(double)frame.pref_addSystemFont/MtgFrame.sizeFontList + MtgFrame.coefMultForSystemFonts));		
		
		Vector<String> vec = new Vector<String>();
		vec.add(new String(MtgFrame.getString("paneListeDecalages2")));
		for (int i = 1; i <= 8; i++) {
			vec.add("+"+Integer.toString(i));
		}
		listeDecalages.setListData(vec);
		listeDecalages.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		listeDecalages.setLayoutOrientation(JList.VERTICAL);
		listeDecalages.setVisibleRowCount(5);
		listeDecalages.setSelectedIndex(frame.pref_addSystemFont);
		listeDecalages.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		JScrollPane scrollpane = new JScrollPane(listeDecalages, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollpane.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 10));
		add(scrollpane);

    setLayout(new FlowLayout());
    add(label1);
    add(scrollpane);
    listeDecalages.ensureIndexIsVisible(listeDecalages.getSelectedIndex());
	}
	
	public void sauveDonnees() {
		frame.pref_addSystemFont = listeDecalages.getSelectedIndex();
	}
	public String titreOnglet() {
		return MtgFrame.getString("ongletPoliceSysteme");
	}	

}
