/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import javax.swing.BorderFactory;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PanePreferencesAnimation extends PaneOptionsPreferences {
	private PaneTransition paneTransition;
	private PaneFrequenceAnimation paneFrequenceAnimation;
	
	/**
	 * Constructeur
	 */
	public PanePreferencesAnimation(MtgFrame frameInit) {
		super(frameInit);
		initComponents();
	}
	
	private final void initComponents() {
		paneTransition = new PaneTransition(frame, frame.pref_moveCyclic, frame.pref_moveNbPoints);
		paneFrequenceAnimation = new PaneFrequenceAnimation(frame, frame.pref_moveFreq, false);
		add(paneTransition);
		add(paneFrequenceAnimation);
		setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));		
	}
	
	public void sauveDonnees() {
		frame.pref_moveCyclic = paneTransition.animationCyclique();
		frame.pref_moveNbPoints = paneTransition.nombrePoints;
		frame.pref_moveFreq = paneFrequenceAnimation.frequenceChoisie();
	}
	
	public String titreOnglet() {
		return MtgFrame.getString("ongletAnimation");
	}	
	
	public boolean donneesValides() {
		return paneTransition.validationNombrePoints();
	}
	
}
