/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.Dimension;
import java.awt.GraphicsDevice;
import java.io.IOException;
import javax.swing.UIManager;
import org.scilab.forge.jlatexmath.TeXFormula;

/**
 *
 * @author Yves
 */
public class Main {
  
  /** Creates a new instance of Main */
  public Main() {
  }
  
  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) {
    // TODO code application logic here
  	// Modifi version JavaWebStart car lors de l'appel args peut tre de dimension 2
  	String path = "";
  	String URLForPost = ""; // Pour un appel en ligne de commande depuis une URL
    try {
  		try {
  			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
  		} catch (Exception e) {e.printStackTrace();} // Si pb, garder le look par defaut }

    	if (args.length != 0) {
    		if (args.length == 2) path = args[1];
    		else {
    			if (args.length == 3) {
    				if (args[0].equals("online")) {
    					URLForPost = args[1];
    					path = args[2]; // Dans ce cas path ne contient pas unURL d'un fichier mais une chane contenant un code base64
    				}
    			}
    			else path = args[0];
    		}
    	}
    	MtgFrame  fenetrePrincipale = new MtgFrame(path, URLForPost);

 	    Dimension dimfen = new Dimension();
	    // On cherche la rsolution de l'cran
	    // Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
 			// GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice(); // Plus utilis version 5.0.1 trop lent sousLinux
 			GraphicsDevice gd = fenetrePrincipale.getGraphicsConfiguration().getDevice();
  		int width = gd.getDisplayMode().getWidth();
 			int height = gd.getDisplayMode().getHeight();
	    if (width <= 800) {
	    	dimfen.width = width;
	    	dimfen.height = height - 30;
	    }
	    else {
		    if (width <= 1024) {
		    	dimfen.width = 950;
		    	dimfen.height = height - 30;
		    }
		    else {
		    	dimfen.width = (int) (width*0.85);
		    	dimfen.height = (int) (height*0.9);
		    }
	    }
	    fenetrePrincipale.setSize(dimfen);
	    // Pour viter un bug de nullPointerException rcursif : 
	    TeXFormula.registerFonts(false);
    }
    catch (IOException e) {
      // On ne fait rien pour laisser la possibilit  l'utilisateur d'enregistrer son travail
    }
  }
  
}
