/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;
import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;

import types.FonteNom;

/**
 * Cette classe est destine  tre insre dans le Jtree du PaneOptionsFigureMenu.
 * Elle maintient unJCheckBoxMenu qui servia lors de l'adaptation du document en cours
 * aux outils choisis.
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class MtgCheckBoxMenuItemForNode extends JCheckBoxMenuItem {
	public MtgCheckBoxMenuItem itemAssocie;
	public static ImageIcon imiBlank = new ImageIcon(MtgFrame.class.getResource("images/BlankIcon24.gif"));
	
	/**
	 * Modifi version 4.3 pour que soit associe l'icne de l'action associe si elle existe
	 * @param itemAsssocieInit
	 */
	public  MtgCheckBoxMenuItemForNode(MtgCheckBoxMenuItem itemAsssocieInit) {
		super(itemAsssocieInit.getText(), null, itemAsssocieInit.isSelected());
		itemAssocie = itemAsssocieInit;
		setBackground(Color.white);
		ImageIcon imi = itemAsssocieInit.actionAssociee.imiconMenu;
		// Modifi version 5.0
		// if (imi == null) imi = MtgFrame.blankIcon;
		if (imi == null) setIcon(imiBlank); 	else setIcon(imi);
		// Ajout version 5.0
		setFont(FonteNom.getFonteNom(MtgFrame.sizeFontMenuItem, FonteNom.Normal, MtgFrame.coefMultForSystemFonts));
		// Car l'augmentation des polices systme pas toujours effective
	}

	@Override
	public void setSelected(boolean b) {
		super.setSelected(b);
		if (itemAssocie != null) itemAssocie.setSelected(b);
	}
	
	// Version 5.0 : J'utilise paintComponent aulieu de paint
	@Override
	public void paintComponent(Graphics g) {
		// TODO Auto-generated method stub
		super.paintComponent(g);
		if (isSelected()) {
			Graphics2D pDC= (Graphics2D) g;
			if (isSelected()) {
				pDC.setColor(Color.blue);
		    Composite originalComposite = pDC.getComposite();
		    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.2f));
		    pDC.fillRect(2, 2, getWidth()-2, getHeight()-2);
		    pDC.setComposite(originalComposite);
		  }		
		}
	}
}
