/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;
import types.Complexe;
import types.Operateur;

/**
 *
 * @author Yves
 */
public class CResultatValeurComplexe extends CResultatValeur {
  
  /** Creates a new instance of CResultatValeurComplexe */
  public CResultatValeurComplexe() {
  }

  // Constructeur avec une valeur initiale
  public CResultatValeurComplexe(CListeObjets liste, CValeurDynamique valeurInit)
  {
    super(liste, valeurInit);
  }
  
  @Override
  protected long nature() {
  	return natResultatValeurComplexe;
  }  

  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(valeurAssociee);    
    CCalculBase ptcalc = new CResultatValeurComplexe(listeCible, (CValeurDynamique)(listeCible.get(ind1, CValeurDynamique.class)));
    return ptcalc;  
  }
  // Ajout pour la version 2.0 calculs sur les complexes.
  // Le rsultat est renvoy dans z
  public void resultatComplexe(boolean infoRandom, Complexe zRes) {
    valeurAssociee.rendValeurComplexe(zRes);
  } 
  
  // Ajout version 4.6
	@Override
	public CCalculBase calculAvecValeursRemplacees() {
		Complexe z= new Complexe();
		valeurAssociee.rendValeurComplexe(z);
		// Modifi version 4.7.2 car ne marchait pas quand on remplaait des valeurs ngatives
		/*
		return new COperation(listeProprietaire, new CConstante(listeProprietaire, z.x), 
				new COperation(listeProprietaire, new CConstante(listeProprietaire, z.y),
						new CConstantei(), Operateur.Mult), Operateur.Plus);
		*/
		double x = z.x;
		double y = z.y;
		CCalculBase xcal, ycal;
		if (x >= 0) xcal = new CConstante(listeProprietaire, x);
		else xcal= new CMoinsUnaire(listeProprietaire, new CConstante(listeProprietaire, Math.abs(x)));
		if (y >= 0) ycal = new CConstante(listeProprietaire, y);
		else ycal= new CMoinsUnaire(listeProprietaire, new CConstante(listeProprietaire, Math.abs(y)));
		if (y == 0) return xcal;
		if (x==0) return new COperation(listeProprietaire, ycal, new CConstantei(listeProprietaire), Operateur.Mult) ;
		return new COperation(listeProprietaire, xcal, new COperation(listeProprietaire, ycal, new CConstantei(listeProprietaire), Operateur.Mult), Operateur.Plus);
	}
}
