/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import java.awt.Cursor;
import java.awt.Point;
import dialogs.MtgDlg;
import dialogs.HTMLInfoDlg;
import mathgraph32.MtgFrame;
import objets.CElementGraphique;
import types.NatureObjet;

// Ajout version 4.9.2
public class OutilHTMLInfo extends Outil {
	private CElementGraphique objet;
	public CElementGraphique objetDesigne; // public car accessible par le dialogue d'historique

	/** Creates a new instance of OutilPtLib */
	public OutilHTMLInfo(MtgFrame frameInit) {
		super(frameInit, true);
	}

	@Override
  public Cursor curseurUtilise() {
		return MtgFrame.defaultCursor;
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageCre;
		frame.outilPointageActif.designationDe(NatureObjet.NToutObjet);
		frame.indication(getString("infoHTML1"));
		frame.outilPointageActif.reset();
	}
  
	@Override
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		objet = elg;
    ajouteClignotementDe(elg);
    frame.cadreActif().videDesignation();
    resetClignotement();
		creeObjet();
	}
	@Override
	public void creeObjet() {
		MtgDlg dlg = new HTMLInfoDlg(frame, objet);
		dlg.setLocationRelativeTo(frame);
		dlg.setVisible(true);
		annuleClignotement();
		frame.activeOutilCapture();
	}


}
