/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;

import objets.CElementGraphique;
import objets.CMarqueSegment;
import objets.CSegment;
import types.NatureObjet;

import mathgraph32.MtgFrame;


public class OutilMarqueSegment extends Outil {
  CSegment segment1;
	
	public OutilMarqueSegment(MtgFrame frameInit) {
		super(frameInit, false); // False car pas de clignotement ncessaire
	}
  
  @Override
  public void select() {
    super.select();
    segment1 = null;
    frame.outilPointageCre.designationDe(NatureObjet.NSegment);
    frame.outilPointageActif = frame.outilPointageCre;
    frame.indication(getString("marqueSegment1"));
  }

  @Override
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (segment1 == null) {
      segment1 = (CSegment) elg;
      creeObjet();
    }
  }
  
  @Override
  public void creeObjet() {
  	CMarqueSegment pt = new CMarqueSegment(frame.cadreActif().listePr, null, false,
      frame.couleurActive(), false,  frame.styleTraitActif(), frame.styleMarqueSegmentActif(), segment1);
   if (frame.ajouteElementAvecVerification(pt)) {
     frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil35"));
     frame.cadreActif().repaintFigureAvecCalcul();
   }
   select();
  }  
}
