/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import dialogs.MesureCoefficientDirecteurDlg;
import mathgraph32.MtgFrame;
import objets.CListeObjets;
import objets.CMesureCoefDir;
import types.NatureCalcul;

public class OutilMesureCoefficientDirecteur extends OutilParDte {
	
	public OutilMesureCoefficientDirecteur(MtgFrame frameInit) {
    super(frameInit);
  }

  @Override
  public void creeObjet() {
  	frame.indication("");
  	// On affiche une bote de dialogue pour demander le nom de la mesure
  	MesureCoefficientDirecteurDlg dlg = new MesureCoefficientDirecteurDlg(frame);
		dlg.setLocationRelativeTo(frame);
  	dlg.setVisible(true);
  	if (dlg.retourOK()) {
	    CMesureCoefDir mes = new CMesureCoefDir(frame.cadreActif().listePr, null, false , droite1,
	    		dlg.listeReperes.repereChoisi(), dlg.editeurNom.getText());
	    if (frame.ajouteElementAvecVerification(mes)) {
	      objetCree = true; // Necessaire  cause du fait que la droite a t ventuellement
	      // nomme et que si on ne cre pas l'objet on remet alors le nom  une chaine vide
	      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil128"));
	    }
  	}
    annuleClignotement();
    select();
  }
	
  boolean nomsPointsIndisp() {
    return true;
  }	
  
	public String chaineIndication(int indEtape) {
		return getString("mesureCoefficientDirecteur1");
	}

  @Override
	public boolean activationValide() {
		CListeObjets liste = frame.cadreActif().listePr;
		return (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)!=0);
	}
	
	@Override
	public String messageActivationNonValide() {
		CListeObjets liste = frame.cadreActif().listePr;
		if (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)==0) return getString("messagePasDeRepere");
		else return "";
	}	  
	
}
