/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;

import mathgraph32.MtgFrame;
import objets.CElementGraphique;
import objets.CObjetDuplique;
import types.NatureObjet;

public class OutilObjetDuplique extends Outil {
  private CElementGraphique element;

  /** Creates a new instance of OutilPtLie */
  public OutilObjetDuplique(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    element = null;
    frame.outilPointageCre.designationDe(NatureObjet.NToutObjet - NatureObjet.NSurface - NatureObjet.NObjetDuplique
      - NatureObjet.NMacro);
    frame.outilPointageActif = frame.outilPointageCre;
    frame.indication(getString("objetDuplique1"));
  }
  
  @Override
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (element == null) {
      element = elg;
      creeObjet();
    }
  }
  
  @Override
  public void creeObjet() {
  	// Modifi version 4.9.9
  	/*
    CObjetDuplique pt = new CObjetDuplique(frame.cadreActif().listePr, null, false, element.couleur, element.nomMasque,
    		element.dec_x, element.dec_y, false, element.rendNom(), element.indiceTailleNom, element );
    		*/
    CObjetDuplique pt = new CObjetDuplique(frame.cadreActif().listePr, null, false, element.couleur, element.nomMasque,
    		element.dec_x, element.dec_y, false, "", element.indiceTailleNom, element );

    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil110"));
    annuleClignotement();
    frame.activeOutilCapture();
  }
  
}
