/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.COrdonneeOrigineRep;
import types.NatureCalcul;
import dialogs.OrdonneeOrigineDlg;

/**
 * Classe cre pour la version 4.5
 * @author Yves
 *
 */
public class OutilOrdonneeOrigineRep extends Outil {

	public OutilOrdonneeOrigineRep(MtgFrame frameInit) {
		super(frameInit, false); // false car pas de clignotement
	}

  @Override
	public void select() {
  	super.select();
		MtgInternalFrame cadre = frame.cadreActif();
		COrdonneeOrigineRep ord = new COrdonneeOrigineRep(frame.cadreActif().listePr, null, false, "", null);
		OrdonneeOrigineDlg dlg = new OrdonneeOrigineDlg(frame, ord, false);
		dlg.setLocationRelativeTo(frame);
		dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(ord))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil152"));    	
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)>0;
	}
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeRepere");
	}
  
	
}
