/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;

import objets.CElementGraphique;
import objets.CPointAncetre;
import types.NatureObjet;

import mathgraph32.MtgFrame;


/**
 * Outil anctre des outils ayant besoin qu'on clique sur un point (droite par coeff directer, point par affixe ...)
 * @author Yves
 *
 */
public class OutilParPoint extends Outil {
	public CPointAncetre point;

  public OutilParPoint(MtgFrame frameInit) {
    super(frameInit, true);
  }
	
  @Override
  public void select() {
    super.select();
    point = null;
    frame.outilPointageCre.designationDe(NatureObjet.NToutPoint);
    frame.outilPointageActif = frame.outilPointageCre;
    frame.indication(chaineIndication(1));
  }

  @Override
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (point == null) {
      point = (CPointAncetre) elg;
      ajouteClignotementDe(elg);
      resetClignotement();
      frame.indication(chaineIndication(2));
      creeObjet();
      annuleClignotement();      
    }
  }  
}
