/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.event.MouseEvent;
import java.util.ListIterator;
import objets.CAffichageLieAPoint;
import objets.CElementBase;
import objets.CListeObjets;
import objets.CPointBase;
import types.NatureObjet;


import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class OutilPointageDecalageFigure extends OutilPointage {
	private int xclic, yclic;
  /** Creates a new instance of OutilPointageDecalageFigure */
  public OutilPointageDecalageFigure(MtgFrame frameInit) {
    super(frameInit);
  }

  @Override
  public void reset() {
    super.reset();
		setActiveCursor(MtgFrame.moveCursor);    
  }
  
	@Override
	public void mousePressed(MouseEvent mouseEvent, MtgInternalFrame cadre) {
		setActiveCursor(MtgFrame.handCursor);
		cadre.paneFigure.setCursor(MtgFrame.handCursor);
		xclic = mouseEvent.getX();
		yclic = mouseEvent.getY();
		
	}

	@Override
	public void mouseDragged(MouseEvent mouseEvent, MtgInternalFrame cadre) {
		int decx = mouseEvent.getX() - xclic;
		int decy = mouseEvent.getY() - yclic;
		CListeObjets liste = cadre.listePr;
		ListIterator<CElementBase> li = liste.listIterator();
		while (li.hasNext()) {
			CElementBase elb = li.next();
			long nat = elb.getNature();
			if (nat == NatureObjet.NPointBase) {
				// Modification version 3.3 : on ne translate plus les points libres punaiss
				CPointBase pt = (CPointBase) elb;
				if (pt.pointLibre) pt.translateDe(decx, decy);
			}
			else {
				if (((nat & (NatureObjet.NAffichageLieAPoint | NatureObjet.NImage)) != 0)
						&& frame.pref_decalageAffichagesLibres) {
					((CAffichageLieAPoint) elb).translateDe(decx, decy);
				}
			}
		}
		aRedessinerDansPaint = true;
		cadre.paneFigure.repaint();
		xclic = mouseEvent.getX();
		yclic = mouseEvent.getY();
	}
	
	// Ajout version 2.0 pour luidit
	@Override
  public void actionDansPaint(MtgInternalFrame cadre) {
		cadre.redessineAvecCalcul();
		aRedessinerDansPaint = false;		
	}

	@Override
	public void mouseReleased(MouseEvent mouseEvent, MtgInternalFrame cadre) {
		setActiveCursor(MtgFrame.moveCursor);
	}
	
	
}
