/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
// Ajout version 4.9.9


package outils;

import java.awt.Insets;
import java.awt.Point;

import dialogs.ProtocoleDialog;
import mathgraph32.MtgFrame;

public class OutilProtocole extends Outil{
	public OutilProtocole(MtgFrame frameInit) {
		super(frameInit, true); // true pour grer le clignotement
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageProtocole.affichageObjetsInterm = false;
		frame.outilPointageProtocole.affichagePartiel = true;
		frame.outilPointageProtocole.affichageObjetsCaches = false;
    frame.outilPointageActif = frame.outilPointageProtocole;
    frame.outilPointageActif.reset();
		ProtocoleDialog dlg = new ProtocoleDialog(frame);
		dlg.setLocationRelativeTo(frame);

    Point pt = frame.getLocationOnScreen();
    int width = frame.getWidth();
    int y = frame.mtgDesktopPane.getLocationOnScreen().y;
  	Insets insets = dlg.getInsets();
    dlg.setLocation(pt.x - insets.left + width - dlg.getWidth() , y + insets.bottom);
    dlg.setVisible(true);
    frame.cadreActif().paneFigure.repaint();
	}

}
