/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package types;

// Important : les repres sont considrs aussi comme des objets de type calcul puisqu'on ne peut pas
// les dsigner avec la souris
public class NatureCalcul {
	static final public long NAucunCalcul =							0;
	static final public long NVariable = 								1;
	static final public long NCalculReel = 							1 << 1;
	static final public long NCalculReelConstant = 			1 << 2;	
	static final public long NSuiteRecurrenteReelle =		1 << 3;
	static final public long NSuiteRecurrenteComplexe =	1 << 4;
	static final public long NSolutionEquation = 				1 << 5;
	static final public long NIntegrale	=								1 << 6;
	static final public long NTestExistence =						1 << 7;
	static final public long NSommeIndicee =						1 << 8;
	static final public long NPartieReelle =						1 << 9;
	static final public long NPartieImaginaire =				1 << 10;
	static final public long NModule = 									1 << 11;
	static final public long NArgument = 								1 << 12;
	static final public long NMesureLongueur = 					1 << 13;
	static final public long NMesureAngleNonOriente =		1 << 14;
	static final public long NMesureAngleOriente = 			1 << 15;
	static final public long NMesureAbscisseSurDroite =	1 << 16;
	static final public long NMesureAbscisseRepere =		1 << 17;
	static final public long NMesureOrdonneeRepere =		1 << 18;
	static final public long NMesureLongueurLigne =			1 << 19;
	static final public long NMesureAirePolygone =			1 << 20;
	static final public long NCalculComplexe =					1 << 21;
	static final public long NFonction			 =					1 << 22;
	static final public long NDerivee =									1 << 23;
	static final public long NFonctionComplexe =				1 << 24;
	static final public long NMesureAffixe = 						1 << 25;
	static final public long NRepere =									1 << 26;
	static final public long NMesureCoefDir =						1 << 27;
	static final public long NMesureProduitScalaire = 	1 << 28;
	static final public long NProduitIndice = 					1 << 29;
	static final public long NFonction2Var = 						1L << 30;
	static final public long NFonction3Var = 						1L << 31;
	static final public long NFonctionComplexe2Var = 		1L << 32;
	static final public long NFonctionComplexe3Var = 		1L << 33;
	// Ajout version 4.3
	static final public long NMaximumFonction				=		1L << 34;
	static final public long NMinimumFonction				=		1L << 35;
	// Ajout version 4.5
	static final public long NAbscisseOrigineRep		=		1L << 36;
	static final public long NOrdonneeOrigineRep		=		1L << 37;
	static final public long NUnitexRep							=		1L << 38;
	static final public long NUniteyRep							=		1L << 39;
	// Ajout version 4.6
	static final public long NTestEquivalence				=		1L << 40;
	// Ajout version 4.6
	static final public long NDeriveePartielle			=		1L << 41;
	// Ajout version 4.6
	static final public long NTestDependanceVariable=		1L << 42;
	// Ajout version 4.7.2
	static final public long NTestNatureOperateur		=		1L << 43;
	// Ajout version 4.7.5
	static final public long NSuiteRecurrenteComplexe2		=		1L << 44;
	static final public long NSuiteRecurrenteReelle2		=		1L << 45;
	static final public long NSuiteRecurrenteComplexe3		=		1L << 46;
	static final public long NSuiteRecurrenteReelle3		=		1L << 47;
	// Ajout version 4.7.9
	static final public long NTestFact		=		1L << 48;
	
	
	
  static public final int nombreTypesObjetsCalcul = 48;
	
	public static final long NFonctionReelle1Variable = NFonction | NDerivee;
	public static final long NTouteFonctionReelle = NFonctionReelle1Variable | NFonction2Var | NFonction3Var | NDeriveePartielle;
	public static final long NFonctionReelleNvar = NFonction2Var | NFonction3Var | NDeriveePartielle; // Ajout version 4.6
	public static final long NTouteFonctionComplexe = NFonctionComplexe | NFonctionComplexe2Var | NFonctionComplexe3Var;
	public static final long NTouteFonctionReelleOuComplexe = NTouteFonctionReelle | NTouteFonctionComplexe;
	public static final long NTouteFonctionReelleOuComplexeSaufDerivee = NFonction | NFonction2Var | NFonction3Var
		| NFonctionComplexe | NFonctionComplexe2Var | NFonctionComplexe3Var;;
	public static final long NTouteMesure = NMesureLongueur | NMesureAngleNonOriente | NMesureAngleOriente
		| NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureLongueurLigne
		| NMesureAirePolygone | NMesureAffixe | NMesureCoefDir | NMesureProduitScalaire;
	
  static final public long NTouteValeurReelle = NVariable | NCalculReel |NCalculReelConstant | NSolutionEquation | NIntegrale
  	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureLongueur
  	| NMesureAngleNonOriente |NMesureAngleOriente | NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere
  	| NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire | NMaximumFonction | NMinimumFonction
  	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur;
  static final public long NTouteValeurReelleSaufConst = NVariable | NCalculReel | NSolutionEquation | NIntegrale
  	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureLongueur
  	| NMesureAngleNonOriente |NMesureAngleOriente | NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere
  	| NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire | NMaximumFonction | NMinimumFonction
  	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur;
  
  static final public long NTouteValeurComplexe = NCalculComplexe | NMesureAffixe;
  static final public long NCalculReelOuComplexe = NCalculReel | NCalculComplexe;
  static final public long NTouteValeurOuFonctionReelle = NTouteValeurReelle | NTouteFonctionReelle | NSuiteRecurrenteReelle
  		| NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 ;
  static final public long NTouteValeurReelleOuComplexe = NTouteValeurReelle | NTouteValeurComplexe;
  // Modifi version 4.9.7. On autorise aussi les fonctions relles
  /*
  static final public long NTouteValeurReelleOuComplexeOuFonctionComplexe = NTouteValeurReelleOuComplexe | NTouteFonctionComplexe | NSuiteRecurrenteComplexe
  		| NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3;
  		*/
  static final public long NTouteValeurReelleOuComplexeOuFonctionReelleOuComplexe = NTouteValeurReelleOuComplexe | NTouteFonctionComplexe | NSuiteRecurrenteComplexe
  		| NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NTouteFonctionReelle;
  static final public long NTouteValeurReelleOuComplexeSaufConst = NTouteValeurReelleSaufConst | NTouteValeurComplexe;
  /* Supprim version 4.9.2 Inutile car quivalent  NToutObjetNumeriquesSaufConst
  static final public long NToutObjetNumeriquePourReclassement = NTouteValeurReelleOuComplexeSaufConst | NTouteFonctionReelleOuComplexe |
  	NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe
  	| NRepere | NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3;
 	*/
    
  // Correction version 5.0.3 : Il faut aussi ajouter les mesures d'abscisse sur droite, d'abscisses et d'ordonnes dans repre et les mesures d'affixe
  /*
  static final public long NTouteValeurPourCommentaireDynamiqueSaufFonction = NVariable | NCalculReel |NCalculReelConstant | NCalculComplexe
		| NSolutionEquation | NIntegrale | NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle
		| NPartieImaginaire | NModule | NArgument | NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir
		| NMesureProduitScalaire | NMaximumFonction | NMinimumFonction   	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep
		| NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur;

	*/
  static final public long NTouteValeurPourCommentaireDynamiqueSaufFonction = NVariable | NCalculReel |NCalculReelConstant | NCalculComplexe
		| NSolutionEquation | NIntegrale | NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle
		| NPartieImaginaire | NModule | NArgument | NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir
		| NMesureProduitScalaire | NMaximumFonction | NMinimumFonction   	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep
		| NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur |
		NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureAngleOriente | NMesureAffixe;
  // Correction version 5.0.3 : Il faut aussi ajouter les mesures d'abscisse sur droite, d'abscisses et d'ordonnes dans repre
  /*
 *   static final public long NTouteValeurReellePourCommentaireDynamique = NVariable | NCalculReel |NCalculReelConstant
		| NSolutionEquation | NIntegrale | NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle
		| NPartieImaginaire | NModule | NArgument | NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir
		| NMesureProduitScalaire | NMaximumFonction | NMinimumFonction   	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep
		| NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur;
 */
  static final public long NTouteValeurReellePourCommentaireDynamique = NVariable | NCalculReel |NCalculReelConstant
		| NSolutionEquation | NIntegrale | NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle
		| NPartieImaginaire | NModule | NArgument | NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir
		| NMesureProduitScalaire | NMaximumFonction | NMinimumFonction   	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep
		| NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur |
		NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureAngleOriente;

  static final public long NTouteValeurPourCommentaireDynamique = NTouteValeurPourCommentaireDynamiqueSaufFonction | NTouteFonctionReelleOuComplexe;
  static final public long NFonctionOuSuiteReelle = NTouteFonctionReelle | NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3;
  static final public long NFonctionOuSuiteComplexe = NTouteFonctionComplexe | NSuiteRecurrenteComplexe | NSuiteRecurrenteComplexe2
  		| NSuiteRecurrenteComplexe3;
  static final public long NCalculOuVariableOuFonctionReelOuComplexe = NVariable | NCalculReel |NCalculReelConstant | NSolutionEquation | NIntegrale
  	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NCalculComplexe
  	| NTouteFonctionReelleOuComplexe | NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3| NSuiteRecurrenteComplexe | NSuiteRecurrenteComplexe2 
  	| NSuiteRecurrenteComplexe3 | NMesureCoefDir | NMesureProduitScalaire
  	| NMaximumFonction | NMinimumFonction | NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact
  	| NTestDependanceVariable | NTestNatureOperateur;
;
	static final public long NAutreCalcul = NSolutionEquation | NIntegrale | NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle
		| NPartieImaginaire | NModule | NArgument | NMesureLongueur | NMesureAngleNonOriente | NMesureAngleOriente
		| NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureLongueurLigne | NMesureAirePolygone
		| NMesureCoefDir | NMesureProduitScalaire | NMaximumFonction | NMinimumFonction | NAbscisseOrigineRep | NOrdonneeOrigineRep
		| NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur;
	// Modifi version 3.4.5
	// static final public long NObjetCalculPourSourcesPrototype = NCalculReel | NCalculReelConstant | NCalculComplexe
	//	| NSuiteRecurrenteReelle | NSuiteRecurrenteComplexe | NVariable | NTouteFonctionReelleOuComplexe | NRepere | NMesureCoefDir;
	static final public long NObjetCalculPourSourcesPrototype = NCalculReel | NCalculComplexe
	| NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe
	|NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NVariable | NTouteFonctionReelleOuComplexeSaufDerivee | NRepere;
	static final public long NObjetCalculPourSourcesPrototypeSaufRepere = NCalculReel | NCalculComplexe
	| NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe
	| NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NVariable | NTouteFonctionReelleOuComplexeSaufDerivee;
	// Modifi version 5.0
	/*
	static final public long NToutCalculNomme = NCalculReel |NCalculReelConstant | NCalculComplexe | NTouteFonctionReelleOuComplexe
		| NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe
		| NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NVariable | NSolutionEquation | NIntegrale
		| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureCoefDir
		| NMesureLongueurLigne | NMesureAirePolygone | NMesureProduitScalaire | NMaximumFonction | NMinimumFonction
		| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur;
		*/
	static final public long NToutCalculNomme = NCalculReel |NCalculReelConstant | NCalculComplexe | NTouteFonctionReelleOuComplexe
			| NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe
			| NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NVariable | NSolutionEquation | NIntegrale
			| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureCoefDir
			| NMesureLongueurLigne | NMesureAirePolygone | NMesureProduitScalaire | NMaximumFonction | NMinimumFonction
			| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact | NTestDependanceVariable
			| NTestNatureOperateur | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureAffixe | NMesureAngleOriente | NMesureAbscisseSurDroite;
	// Modifi version 5.0
	/*
	static final public long NToutCalculNommeSaufConst = NCalculReel | NCalculComplexe | NTouteFonctionReelleOuComplexe
	| NDerivee | NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe
	| NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NVariable | NSolutionEquation | NIntegrale
	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument
	| NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire | NMaximumFonction | NMinimumFonction
	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact | NTestDependanceVariable | NTestNatureOperateur;	
	*/
	static final public long NToutCalculNommeSaufConst = NCalculReel | NCalculComplexe | NTouteFonctionReelleOuComplexe
	| NDerivee | NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe
	| NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NVariable | NSolutionEquation | NIntegrale
	| NTestExistence | NSommeIndicee | NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument
	| NMesureLongueurLigne | NMesureAirePolygone | NMesureCoefDir | NMesureProduitScalaire | NMaximumFonction | NMinimumFonction
	| NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep | NTestEquivalence | NTestFact | NTestDependanceVariable
	| NTestNatureOperateur | NMesureAbscisseRepere | NMesureOrdonneeRepere | NMesureAffixe | NMesureAngleOriente | NMesureAbscisseSurDroite;	

	static final public long NToutObjetNumeriquesSaufConst = NTouteValeurReelleSaufConst | NTouteValeurComplexe
		| NFonctionOuSuiteReelle | NFonctionOuSuiteComplexe | NRepere;
	static final public long NToutObjetNumerique = NTouteValeurReelle | NTouteValeurComplexe
		| NFonctionOuSuiteReelle | NFonctionOuSuiteComplexe | NRepere;
	static final public long NCalculOuFonctionNonConstante = NCalculReel | NCalculComplexe | NTouteFonctionReelle | NTouteFonctionComplexe;
	public final static long NObjetCalculSourcePourConst = NCalculReel | NCalculComplexe 	| NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2
			| NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe | NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3 | NVariable | NTouteFonctionReelleOuComplexe;
	// Modification pour la version 3.1.5. On peut aussi choisir une variable comme objet final
	//  condition qu'elle ait d'abord t choisie dans les objets sources.
	public static final long NObjetFinalNumerique = NVariable | NCalculReel | NCalculReelConstant | NSolutionEquation | NIntegrale
	| NTestExistence | NSommeIndicee |NProduitIndice | NPartieReelle | NPartieImaginaire | NModule | NArgument | NMesureLongueur
	| NMesureAngleNonOriente |NMesureAngleOriente | NMesureAbscisseSurDroite | NMesureAbscisseRepere | NMesureOrdonneeRepere
	| NMesureLongueurLigne | NMesureAirePolygone | NCalculComplexe | NMesureAffixe | NTouteFonctionReelle | NTouteFonctionComplexe
	| NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3 | NSuiteRecurrenteComplexe | NSuiteRecurrenteComplexe2
	| NSuiteRecurrenteComplexe3 | NDerivee 	| NMesureCoefDir | NRepere | NMesureProduitScalaire
	| NMaximumFonction | NMinimumFonction | NAbscisseOrigineRep | NOrdonneeOrigineRep | NUnitexRep | NUniteyRep
	| NTestEquivalence | NTestFact | NDeriveePartielle | NTestDependanceVariable | NTestNatureOperateur;
	public static final long NToutCalculOuFonctionReelleOuComplexe = NCalculReelConstant | NCalculReel | NCalculComplexe |
		NFonction | NFonction2Var | NFonction3Var | NFonctionComplexe | NFonctionComplexe2Var | NFonctionComplexe3Var;
	// Ajout version 4.5.2
	public static final long NCalculOuFonctionParFormule = NCalculReelOuComplexe | NFonction | NFonction2Var
			| NFonction3Var | NFonctionComplexe | NFonctionComplexe2Var | NFonctionComplexe3Var;
	// Ajout version 4.7.5
	public static final long NTouteSuiteRecurrenteReelle = NSuiteRecurrenteReelle | NSuiteRecurrenteReelle2 | NSuiteRecurrenteReelle3;
	public static final long NTouteSuiteRecurrenteComplexe = NSuiteRecurrenteComplexe | NSuiteRecurrenteComplexe2 | NSuiteRecurrenteComplexe3;
}