/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package types;
/*
 * Operateur.java
 *
 * Created on 1 juillet 2004, 20:33
 */

/**
 *
 * @author  Yves
 * @version 
 */
// Classe qui par ses mthodes de classe permet de dfinir les diffrents types d'oprateurs
public class Operateur {

  /** Creates new Operateur */
  public Operateur() {
  }
  public static final int Plus = 0;
  public static final int Moin = 1;
  public static final int Mult = 2;
  public static final int Divi = 3;
  public static final int Inf = 4;
  public static final int Sup = 5;
  public static final int InfOuEgal = 6;
  public static final int SupOuEgal = 7;
  public static final int Egalite = 8;
  public static final int Diff = 9;
  // Ajout version 4.9.5 : Oprateurs and et or
  public static final int And = 10;
  public static final int Or = 11;
  
  // Modifi version 4.9.5 : Les oprateurs logiques sont considrs comme des tests bien qu'ils aient une priorit infrieure
  public final static boolean estTest(int val) {
  	// Modifi version 4.9.5
  	// return (val == Inf) || (val == Sup) || (val == InfOuEgal) || (val == SupOuEgal) || (val == Egalite) || (val == Diff);
  	return (val == Inf) || (val == Sup) || (val == InfOuEgal) || (val == SupOuEgal) || (val == Egalite) || (val == Diff)
  			|| (val == And) || (val == Or);
  }
  public final static String chaineOperateur(int val) {
  	switch (val) {
  	case Plus : return "+";
  	case Moin : return "-";
  	case Mult : return "*";
  	case Divi : return "/";
  	case Inf : return "<";
  	case Sup : return ">";
  	case InfOuEgal : return "<=";
  	case SupOuEgal : return ">=";
  	case Egalite : return "=";
  	case Diff : return "<>";
  	// Ajout version 4.9.5
  	case And : return "&";
  	case Or : return "|";
  	default : return "";
  	}
  }
  
  // Rajout version 4.6
  public final static String chaineOperateurLatex(int val) {
  	switch (val) {
  	case InfOuEgal : return "\\le ";
  	case SupOuEgal : return "\\ge ";
  	case Diff : return "\\;\\ne\\; ";
  	case And : return "\\,\\&";
  	case Or : return "\\,|";
  	default : return chaineOperateur(val);
  	}
  }

}
